-- ============== ,    
/*
### :   (c)2014
### :     :
###                - object_id
###                - 
###                - Heap   
###                -   ,    (   )
###                -    
###                -      
*/
 
SELECT t.object_id AS o_id
     , sch.name                              AS sch_name
     , t.name                                AS o_name 
     , ISNULL( idx.name, 'Heap Table' )      AS idx_name
     , idx.type_desc                         AS idx_type
     , fg.data_space_id                      AS fg_id
     , fg.name                               AS fg_name
     , CAST( part.rows AS FLOAT )            AS num_rows
     , SUM( au.total_pages ) *8              AS total_pages_kb
     , SUM( au.total_pages ) *8 /1024        AS total_pages_mb
     , SUM( au.used_pages ) *8               AS used_pages_kb
     , SUM( au.used_pages ) *8 /1024         AS used_pages_mb
 
FROM sys.tables AS t
 
INNER JOIN sys.indexes AS idx
        ON idx.object_id = t.object_id
       AND ( idx.index_id = 0 OR idx.index_id = 1 )
    -- ###  -  = 0 |   = 1
 
INNER JOIN sys.partitions AS part
        ON part.object_id = t.object_id
       AND part.index_id = idx.index_id
 
INNER JOIN sys.filegroups AS fg
        ON fg.data_space_id = idx.data_space_id
 
INNER JOIN sys.allocation_units AS au 
        ON au.container_id = part.partition_id
       AND au.data_space_id = fg.data_space_id
 
INNER JOIN sys.objects AS obj
        ON obj.object_id = t.object_id
 
INNER JOIN sys.schemas AS sch
        ON sch.schema_id = obj.schema_id
 
WHERE NOT t.name LIKE 'sys%'
--- ###    sys%
 
GROUP BY t.object_id
       , sch.name
       , t.name
       , idx.name
       , idx.type_desc
       , fg.data_space_id
       , fg.name, part.rows
 
ORDER BY total_pages_kb DESC;

-- ==============   

/* ###     */
USE [master];
GO
ALTER DATABASE [projectDB] ADD FILEGROUP [fg_userdata];
GO
 
/* ###       */
ALTER DATABASE [projectDB] ADD FILE (   NAME = N'data_file_01'
                                      , FILENAME = N'D:\mssql\data\projectDB\data_file_01.ndf' 
                                      , SIZE = 1048576KB 
                                      , FILEGROWTH = 524288KB 
                                    ) TO FILEGROUP [fg_userdata];
GO
 
/* ###  [fg_userdata]       */
USE [projectDB];
GO
ALTER DATABASE [projectDB] MODIFY FILEGROUP [fg_userdata] DEFAULT;
GO
